###
###                    Clculo de REML para modelo de area                     
###                              Proyecto SAMPLE                               
###                              Proyecto SAMPLE                               
###                                5 deMayo 2009                               
###

### AUTOR: Laureano Santamaria Arana

### Editado por:
### con fecha:
### cambios realizados:         

### Comentarios: 

#source("C:\\Documents and Settings\\Laureano\\Mis documentos\\My Dropbox\\Sample\\Software\\Capitulo 2\\Omega.R")
source("Omega.R")

REML.area <- function(X, Y, W, D, md, ndi, sigma0, sigma1, sigma2, rho, MAXITER = 500) { 
    
    n <- nrow(X)
    p <- ncol(X)

    Sd.inv<-matrix(0, nrow=n, ncol=n)
    
    mdcum <- cumsum(md)
    ndcum <- cumsum(ndi)
    

    for(ITER in 1:MAXITER){
        
        F1 <- sigma1/sigma0  
        F2 <- sigma2/sigma0

        mR <- 0
        mF <- 0
        mJ <- 0
        mJD <- 0
        for(d in 1:D) {      
            if (d==1) {
                Inicio <-1
                Pr <-1
            }
            if (d!=1) {
                Pr <- (ndcum[mdcum[d-1]]+1)
                Inicio <-mdcum[d-1]+1
            }
            Fin  <- ndcum[mdcum[d]]
            Nd <- Fin-Pr+1
 
            Wd <- W[Pr:Fin,Pr:Fin]
            yd <- Y[Pr:Fin]
            Xd <- X[Pr:Fin,]
                   
            D1Nd <- matrix(0,Nd,md[d])
            i <- 1
            for(k in 1:md[d]) {
                for(j in 1:ndi[Inicio+k-1]) {
                    D1Nd[i,k]<-1 
                    i<- i+1
                }
            } 
            Imd<-diag(md[d])
            Omegad <- Calcula_Omegad(md[d], rho)
            OmegadDeriv <- Deriva_Omegad (md[d], rho, Omegad)
            OmegadInv <- Inversa_Omegad(md[d], rho)
 
            sld.inv <- solve(OmegadInv+F2*t(D1Nd)%*%Wd%*%D1Nd)
            Ld.inv <- Wd-F2*Wd%*%D1Nd%*%sld.inv%*%t(D1Nd)%*%Wd
       
            UnoNd <-as.matrix(rep(1,Nd))

            T1 <- F1*Ld.inv%*%UnoNd%*%t(UnoNd)%*%Ld.inv
            T2 <- 1+(F1*t(UnoNd)%*%Ld.inv%*%UnoNd)
        
            Sigmad.inv <- Ld.inv - (T1/T2[1,1])  
            Sd.inv[Pr:Fin,Pr:Fin] <- Sigmad.inv
        
            mR <- mR + t(Xd)%*%Sigmad.inv%*%Xd              
            mF <- mF + t(Xd)%*%Sigmad.inv%*%UnoNd%*%t(UnoNd)%*%Sigmad.inv%*%Xd
            mJ <- mJ + t(Xd)%*%Sigmad.inv%*%D1Nd%*%Omegad%*%t(D1Nd)%*%Sigmad.inv%*%Xd
            mJD <- mJD + t(Xd)%*%Sigmad.inv%*%D1Nd%*%OmegadDeriv%*%t(D1Nd)%*%Sigmad.inv%*%Xd
        }
    
        R <- solve(mR)     
    
        mA <- 0  
        mB <- 0  
        mC <- 0  
        mD <- 0  
        mE <- 0  
        mG <- 0  
        mH <- 0  
        mK <- 0  
        mL <- 0  
        mHD <- 0  
        mKD <- 0  
        mLD <- 0  
        mM <- 0  
        mN <- 0  
        mP <- 0  
        mQ <- 0  
        mR <- 0  
        mS <- 0  
        mQD <- 0  
        mRD <- 0  
        mSD <- 0  
        mT <- 0  
        mV <- 0  
        mW <- 0     
        mTD <- 0  
        mVD <- 0  
        mWD <- 0  
        mTDD <- 0  
        mVDD <- 0  
        mWDD <- 0  
    
        for(d in 1:D) {      
            if (d==1) {
                Inicio <-1
                Pr <-1
            }
            if (d!=1) {
                Pr <- (ndcum[mdcum[d-1]]+1)
                Inicio <-mdcum[d-1]+1
            }
            Fin  <- ndcum[mdcum[d]]
            Nd <- Fin-Pr+1
 
            Wd <- W[Pr:Fin,Pr:Fin]
            yd <- Y[Pr:Fin]
            Xd <- X[Pr:Fin,]
                   
            D1Nd <- matrix(0,Nd,md[d])
            i <- 1
            for(k in 1:md[d]) {
                for(j in 1:ndi[Inicio+k-1]) {
                    D1Nd[i,k]<-1 
                    i<- i+1
                }
            } 
       
            UnoNd <-as.matrix(rep(1,Nd))
            Omegad <- Calcula_Omegad(md[d], rho)
            OmegadDeriv <- Deriva_Omegad (md[d], rho, Omegad)
                       
            mA <- mA + t(yd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%yd
            mB <- mB + t(yd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%Xd       
            mC <- mC + t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%yd
        
            T3 <- t(yd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%UnoNd%*%t(UnoNd)%*%Sd.inv[Pr:Fin,Pr:Fin]
        
            mD <- mD + T3%*%yd
            mE <- mE + T3%*%Xd
        
            T4 <- Sd.inv[Pr:Fin,Pr:Fin] - Sd.inv[Pr:Fin,Pr:Fin]%*%Xd%*%R%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]
        
            mG <- mG + t(UnoNd)%*%T4%*%UnoNd                  
            mH <- mH + sum(diag(t(D1Nd)%*%T4%*%D1Nd%*%Omegad))
            mHD <- mHD + sum(diag(t(D1Nd)%*%T4%*%D1Nd%*%OmegadDeriv))
            
            T5 <- t(yd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad%*%t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]            
            mK <- mK + T5%*%yd
            mL <- mL + T5%*%Xd

            T5D <- t(yd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv%*%t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]
            mKD <- mKD + T5D%*%yd
            mLD <- mLD + T5D%*%Xd
            
            T6 <- t(UnoNd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%UnoNd
                      
            mM <- mM + T6%*%T6
            mN <- mN + T6%*%t(UnoNd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%Xd%*%R%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%UnoNd
            mP <- mP + t(UnoNd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%Xd%*%R%*%mF%*%R%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%UnoNd
            
            T7 <- t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%Xd%*%R
           
            T8 <- t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%UnoNd%*%t(UnoNd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad
            
            mQ <- mQ + sum(diag(T8))
            mR <- mR + sum(diag(T7%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%UnoNd%*%t(UnoNd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad))
            mS <- mS + sum(diag(T7%*%mF%*%R%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad))

            T8D <- t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%UnoNd%*%t(UnoNd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv
           
            mQD <- mQD + sum(diag(T8))
            mRD <- mRD + sum(diag(T7%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%UnoNd%*%t(UnoNd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv))
            mSD <- mSD + sum(diag(T7%*%mF%*%R%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv))

            mT <- mT + sum(diag(t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad%*%t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad))
            mV <- mV + sum(diag(T7%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad%*%t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad))
            mW <- mW + sum(diag(T7%*%mJ%*%R%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad))
            
            mTD <- mTD + sum(diag(t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad%*%t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv))
            mVD <- mVD + sum(diag(T7%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%Omegad%*%t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv))
            mWD <- mWD + sum(diag(T7%*%mJ%*%R%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv))

            mTDD <- mTDD + sum(diag(t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv%*%t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv))
            mVDD <- mVDD + sum(diag(T7%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv%*%t(D1Nd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv))
            mWDD <- mWDD + sum(diag(T7%*%mJD%*%R%*%t(Xd)%*%Sd.inv[Pr:Fin,Pr:Fin]%*%D1Nd%*%OmegadDeriv))
            
        }

        S <- matrix(0, nrow=4, ncol=1)
        Fisher <- matrix(0, nrow=4, ncol=4)
            
        S[1,1] <- - (n-p)/(2*sigma0) + mA/(2*sigma0*sigma0) - (mB%*%R%*%mC)/(2*sigma0*sigma0)
        S[2,1] <- - mG/2 + mD/(2*sigma0) - (mE%*%R%*%mC)/sigma0 + (mB%*%R%*%mF%*%R%*%mC)/(2*sigma0)
        S[3,1] <- - mH/2 + mK/(2*sigma0) - (mL%*%R%*%mC)/sigma0 + (mB%*%R%*%mJ%*%R%*%mC)/(2*sigma0)
        S[4,1] <- F2*(- mHD/2 + mKD/(2*sigma0) - (mLD%*%R%*%mC)/sigma0 + (mB%*%R%*%mJD%*%R%*%mC)/(2*sigma0))

        Fisher[1,1] <- (n-p)/(2*sigma0*sigma0)
        Fisher[1,2] <- mG/(2*sigma0)
        Fisher[1,3] <- mH/(2*sigma0)
        Fisher[1,4] <- F2*(mHD/(2*sigma0))
        Fisher[2,1] <- Fisher[1,2]      
        Fisher[2,2] <- mM/2 - mN + mP/2     
        Fisher[2,3] <- mQ/2 - mR + mS/2              
        Fisher[2,4] <- F2*(mQD/2 - mRD + mSD/2)
        Fisher[3,1] <- Fisher[1,3]       
        Fisher[3,2] <- Fisher[2,3]       
        Fisher[3,3] <- mT/2 -mV + mW/2       
        Fisher[3,4] <- F2*(mTD/2 -mVD + mWD/2)
        Fisher[4,1] <- Fisher[1,4]
        Fisher[4,2] <- Fisher[2,4]
        Fisher[4,3] <- Fisher[3,4]
        Fisher[4,4] <- F2*F2*(mTDD/2 -mVDD + mWDD/2)
        
        DET <- det(Fisher)
        if (DET<0.00000000001) {
            ITER <- 500
            break
        }
        Fisher.inv <- solve(Fisher)
        dif <- Fisher.inv%*%S

        sigma0 <- sigma0 + dif[1]
        dif[2] <- dif[2] * sigma0
        dif[3] <- dif[3] * sigma0             
        sigma1 <- sigma1 + dif[2]
        sigma2 <- sigma2 + dif[3] 
        rho <- rho + dif[4]

        if(abs(dif[1])<0.00001 & abs(dif[2])<0.00001 & abs(dif[3])<0.00001 & abs(dif[4])<0.00001)
            break
    }
    return(list(sigma0,sigma1,sigma2,rho,Fisher.inv,ITER,R))

}
